;REMOTE SCRIPT START

AltIDirectDraw_SetDisplayMode(p1, p2, p3, p4)
{
	r := IDirectDraw_SetDisplayMode(p1, p2, p3, p4)	
	(p4=8) ? _rect_setscale(g_.cfg.FMVScale) : _rect_setscale()
	return r    
}

Alt_CreateSurface(pIDirectDraw, pSurfaceDesc, ppSurface, pIUnknown)
{
	g_.DDSDesc[] := pSurfaceDesc
	if (r := __IDirectDraw_CreateSurface(pIDirectDraw, pSurfaceDesc, ppSurface, pIUnknown, A_eventinfo))
		return r
	if (g_.cfg.NoScan and g_.proxies.32bit and (g_.DDSDesc.ddsCaps.dwCaps & DDSCAPS_PRIMARYSURFACE))
	{
		g_.proxies.D3D    := new D3D2Device(640<<16|480)
		(g_.proxies.32bit := new SurrogateSurface("X8RGB",,True)).GetHandle(g_.proxies.D3D.Device2)
		g_.proxies.shader := d3D9_DDI_CreatePixelShader(g_d3D9_DDI.shader_code, "LineDoubling")
		rect.left := 0, rect.top := 0, rect.right := 640, rect.bottom := 480
	}
	return r
}	

Alt_SetEntries(p1, p2, p3, p4, p5)
{
	if not g_.cfg.NoScan
		return IDirectDrawPalette_SetEntries(p1, p2, p3, p4, p5)
	dllcall("RtlMoveMemory", ptr, g_.palette+(p3)*4, ptr, p5, int, (p4)*4)	
	Pal2RGB(g_.proxies.prim.surface)		
	return 0
}

Alt_Unlock(p1, p2)
{
	if (g_.cfg.NoScan and g_.proxies.32bit)
	{
		Pal2RGB(g_.proxies.prim.surface)	
		DEVICE2_RECT.Text    := g_.proxies.32bit.Handle
		DEVICE2_RECT.Device2 := g_.proxies.D3D.Device2
		d3D9_DDI_SetShaderOverride(g_.proxies.shader)
		dllcall(g_.Dev2_DrawRect, uint, DEVICE2_RECT[], uint, rect[], float, 0, uint)
		d3D9_DDI_RestoreShader()
		dllcall(IDirectDrawSurface.blt, uint, g_.primary, uint,  _rect[]
		                              , uint, g_.proxies.D3D.surface, uint, 0
									  , uint, DDBLTFAST_NOCOLORKEY | DDBLT_WAIT, uint, 0, uint)	
		RETURN							  
									  
	}  
	return Surface2Unlock(p1, p2)	
}

