;REMOTE SCRIPT START 
global g_oni_surfaceentry := struct("LPVOID pSurface; LPVOID ParentTexture; DWORD ww; DWORD hh; DWORD type; DWORD Format;")
global g_oni_correction   := round(480/432*10)/10
global g_oni_desk         := GetDeskTopResolution() 
global g_oni_copysrc      := struct("DWORD x; DWORD y; DWORD w; DWORD h;")
global g_oni_copydst      := struct("DWORD x; DWORD y;")
global g_oni_flipsrc      := struct("DWORD x; DWORD y; DWORD w; DWORD h;")
global g_oni_flipsrc_m    := struct("DWORD x; DWORD y; DWORD w; DWORD h;")
global g_oni_flipdst      := struct("DWORD x; DWORD y; DWORD w; DWORD h;")
global g_oni_rttrect      := struct("DWORD x; DWORD y; DWORD w; DWORD h;")
global g_oni_src, g_oni_dst, g_oni_pntsize, g_oni_hwin, g_oni_ignorecopy
global g_oni_dummy        := new Collection()
global g_oni_alphatexts   := new Collection()
global g_oni_input, g_oni_room
logerr(IDirect3DDevice8.Hook("CopyRects"))
logerr(IDirect3DDevice8.Hook("Present", "OniPresent"))
HDHOOKS_DATA8.pIDirect3DDevice8_Present := IDirect3DDevice8.present

HDHOOKS_DATA8.TEXTSWAP8_DATA    := TEXTSWAP8_DATA[]
HDHOOKS_DATA8.AlphaReplacements := g_oni_alphatexts.pc

logerr("UnLockTexture8RectHook:  " . InstallHook("AltUnLockTexture8Rect", pUnlockTexture, "peixoto.dll", "UnLockTexture8RectHook"))
IDirect3DTexture8.UnLockRect := pUnlockTexture

logerr(IDirect3DMSurface8.UnHook("lockRect"))
logerr(IDirect3DMSurface8.dllHook("lockRect", "LockManagedSurface8RectHook"))
TEXTSWAP8_DATA.pIDirect3DMSurface8_lockRect  := IDirect3DMSurface8.lockRect

logerr(IDirect3DTexture8.UnHook("lockRect"))
logerr(IDirect3DTexture8.dllHook("lockRect", "LockTexture8RectHook"))
TEXTSWAP8_DATA.pIDirect3DTexture8_lockRect  := IDirect3DTexture8.lockRect

logerr(IDirect3DDevice8.UnHook("SetTexture"))
logerr(IDirect3DDevice8.dllHook("SetTexture", "OniSetTexture8Hook"))
TEXTSWAP8_DATA.pIDirect3DDevice8_SetTexture  := IDirect3DDevice8.SetTexture

logerr(IDirect3DTexture8.UnHook("Release"))
logerr(IDirect3DTexture8.dllHook("Release", "OniReleaseTexture8Hook"))
TEXTSWAP8_DATA.pIDirect3DTexture8_Release  := IDirect3DTexture8.Release

TEXTSWAP8_DATA.pTextureFound			   := RegisterCallback("OniLoadReplacement", "F")

InitFileHooks((g_.cfg.mods := (g_.cfg.crashfix) ? g_.cfg.injector_dir "\Patches\Onimusha" : "?"))	


IDirect3DDevice8_CopyRects(p1, p2, p3, p4, p5, p6)
{
	if g_oni_ignorecopy
		return  dllcall(IDirect3DDevice8.CopyRects, uint, p1, uint, p2, uint, p3, uint, p4, uint, p5, uint, p6)
	if ( (g_oni_surfaceentry[] := g_TextSwap8.Surfaces.Value(p5)) )
	{
		;logerr("Surface is known")
		if (rep := g_TextSwap8.Replacements.Value(g_oni_surfaceentry.ParentTexture))
		{
			g := dllcall(IDirect3DTexture8.GetSurfaceLevel, uint, rep, uint, 0, "uint*", pRepSurface)
			;logerr("Get surface level" g)
			pRepSurface ? p5 := pRepSurface
		}		
		else	
		{
			;logerr("But not acounted for")
			dllcall(IDirect3DDevice8.CreateTexture, uint, p1, uint, g_oni_surfaceentry.ww*HDHOOKS_DATA8.scale_delta, uint, g_oni_surfaceentry.hh*HDHOOKS_DATA8.scale_delta
												  , uint, 1, uint, 0, uint, g_oni_surfaceentry.format, uint, 0, "uint*", pTexture)
			pTexture ? g_TextSwap8.Replacements._add(g_oni_surfaceentry.ParentTexture, pTexture)	
			g := dllcall(IDirect3DTexture8.GetSurfaceLevel, uint, pTexture, uint, 0, "uint*", pRepSurface)
			;logerr("Get surface level" g)
			pRepSurface ? p5 := pRepSurface	
			dllcall(IDirect3DDevice8.SetRenderState, uint, p1, uint, 26, uint, 1)
			dllcall(IDirect3DDevice8.SetRenderState, uint, p1, uint, 154, float, g_oni_pntsize)
		}
	} else logerr("Unknown")
	if (r := dllcall(IDirect3DDevice8.CopyRects, uint, p1, uint, p2, uint, g_oni_copysrc[], uint, 1, uint, p5, uint, g_oni_copydst[]))
		logerr("Failed")
	;r := dllcall(IDirect3DDevice8.CopyRects, uint, p1, uint, p2, uint, g_oni_copysrc[], uint, 1, uint, p5, uint, g_oni_copydst[])	
	pRepSurface ? dllcall(IDirect3DSurface8.release, uint, pRepSurface)
	return r
}

Alt_CreateDevice(p1, p2, p3, p4, p5, p6, p7)
{
	D3DPRESENT_PARAMETERS[]                               := p6
	D3DPRESENT_PARAMETERS.windowed                        := True
	D3DPRESENT_PARAMETERS.FullScreen_PresentationInterval := 0
	D3DPRESENT_PARAMETERS.SwapEffect                      := 4
	g_HDHooks.h *= g_oni_correction, g_HDHooks.w := g_HDHooks.h*4/3
	g_oni_hwin := D3DPRESENT_PARAMETERS.hDeviceWindow
	;g_oni_desk := {"w" : 640, "h" : 480}
	dllcall("user32.dll\MoveWindow", uint, D3DPRESENT_PARAMETERS.hDeviceWindow, uint, 0, uint, 0, uint, g_oni_desk.w, uint, g_oni_desk.h, uint, 1)
		
	r := IDirect3D8_CreateDevice(p1, p2, p3, p4, p5, p6, p7)	
		
	g_oni_copysrc.x := D3DVIEWPORT8.X
	g_oni_copysrc.w := D3DVIEWPORT8.width+D3DVIEWPORT8.X
	g_oni_copysrc.h := D3DVIEWPORT8.height
	
	g_oni_flipsrc.w := g_HDHooks.w
	g_oni_flipsrc.x := 0
	g_oni_flipsrc.y := 32*HDHOOKS_DATA8.scale_delta
	g_oni_flipsrc.h := 432*HDHOOKS_DATA8.scale_delta+g_oni_flipsrc.y
		
	g_oni_flipsrc_m.w := g_HDHooks.w
	g_oni_flipsrc_m.x := 0
	g_oni_flipsrc_m.y := 16*HDHOOKS_DATA8.scale_delta
	g_oni_flipsrc_m.h := 448*HDHOOKS_DATA8.scale_delta+g_oni_flipsrc_m.y
	
	g_oni_flipdst.w := g_oni_desk.h*4/3
	g_oni_flipdst.x := (g_oni_desk.w-g_oni_flipdst.w)/2
	g_oni_flipdst.w += g_oni_flipdst.x
	g_oni_flipdst.h := g_oni_desk.h
	g_oni_flipdst.y := 0	
	HDHOOKS_DATA8.dst := g_oni_flipdst[]

	g_oni_pntsize := HDHOOKS_DATA8.scale_delta*HDHOOKS_DATA8.scale_delta	
}

AltCreateFileW(p1, p2, p3, p4, p5, p6, p7)
{
	static block = True
	file := strget(p1, "UTF-16")
	if instr(file, "image\movie") and block
	{
		if not instr(file, "E.mpg")
			stringreplace, file_e, file, .mpg, E.mpg
		
		block := False
		if fileexist(file_e)
			PlayFMVOnWindow(file_e, g_oni_hwin, g_.cfg.FMV_scale)
		else PlayFMVOnWindow(file, g_oni_hwin, g_.cfg.FMV_scale)
		block := True
		return -1
		/*
		VarSetCapacity(file_name, (strlen(file)+1)*2)
		strput(file, &file_name, "UTF-16")
		return CreateFileW(&file_name, p2, p3, p4, p5, p6, p7)
		*/
		
	} else return CreateFileW(p1, p2, p3, p4, p5, p6, p7)	
}

/*
Alt_EndScene(p1)
{
	
	g_TextSwap8.states := []
	g_TextSwap8.passes := 0
	
	static font_rect
	font_rect ?: font_rect := struct(D3D8_RECT)
	, font_rect.top       := 300
	, font_rect.bottom    := 480
	, font_rect.right     := 640
	, font_rect.left      := 0
	
	states := ""
	for k, v in g_TextSwap8.states
	{
		for kk, vv in v
			states .= vv . " "
		states .= "`n"
	}
	
	dllcall(IDirect3DDevice8.GetVertexShader, uint, p1, "uint*", current_vshader)
	dllcall(IDirect3DDevice8.SetVertexShader, uint, p1, uint, 0x104)
	dllcall(IDirect3DDevice8.GetPixelShader, uint, p1, "uint*", current_shader)
	dllcall(IDirect3DDevice8.SetPixelShader, uint, p1, uint, g_TextSwap8.shader)	
	dllcall("peixoto.dll\d3D8Write", uint, g_.d3D8Font, str
	, g_TextSwap8.passes " passes`n" states, uint, font_rect[], uint, 0x000000ff)
	dllcall(IDirect3DDevice8.SetPixelShader, uint, p1, uint, current_shader)
	dllcall(IDirect3DDevice8.SetVertexShader, uint, p1, uint, current_vshader)
		
	return IDirect3DDevice8_EndScene(p1)
}
*/	

OniPresent(p1, p2, p3, p4, p5)
{
	static freq, lastflip = 0 
	HDHOOKS_DATA8.src := numget(0x7ae0bc+0, "uint") ? g_oni_flipsrc_m[] : g_oni_flipsrc[]
	r := dllcall(IDirect3DDevice8.Present, uint, p1, uint, HDHOOKS_DATA8.src, uint, HDHOOKS_DATA8.dst, uint, p4, uint, p5)	
		
	freq ?:	DllCall("QueryPerformanceFrequency", "Int64*", freq)			
	DllCall("QueryPerformanceCounter", "Int64*", timenow)
	
	while not (timenow - lastflip)/freq*1000 >= 33.3
		DllCall("QueryPerformanceCounter", "Int64*", timenow)
	lastflip := timenow
	return r
}

AltUnLockTexture8Rect(p1, p2)
{
	if (rep := g_oni_alphatexts.Value(p1)	)
	{
		dllcall("peixoto.dll\OniReleaseTexture8Hook", uint, rep)
		g_oni_alphatexts.discard(p1)
	}
	if ! (g_TextSwap8.entry[] := g_TextSwap8.textures.value(p1))
		return dllcall(IDirect3DTexture8.UnLockRect, uint, p1, uint, p2)
	if ! (g_TextSwap8.entry.format = d3D8SetPixelFormat("A4RGB"))
		return dllcall(IDirect3DTexture8.UnLockRect, uint, p1, uint, p2)
	if (rep := g_oni_alphatexts.value(p1))
	{
		dllcall("peixoto.dll\OniReleaseTexture8Hook", uint, rep)
		g_oni_alphatexts.discard(p1)
	}
	r := dllcall(IDirect3DDevice8.CreateTexture, uint, g_.pDevice8, uint, g_TextSwap8.entry.ww, uint, g_TextSwap8.entry.hh, uint, 1
	                                           , uint, 0, uint, d3D8SetPixelFormat("RG6B"), uint, 1, "uint*", pTexture)
	if pTexture 
	{
		g_oni_alphatexts._add(p1, pTexture)		
		dllcall(IDirect3DTexture8.UnLockRect, uint, p1, uint, p2)
		dllcall(IDirect3DTexture8.GetSurfaceLevel, uint, pTexture, uint, 0, "uint*", pDest)
		dllcall(IDirect3DTexture8.GetSurfaceLevel, uint, p1, uint, 0, "uint*", pSource)
		
		g_oni_ignorecopy := True
		dllcall("peixoto.dll\d3D8LoadSurfaceFromSurface", uint, pDest, uint, pSource)
		dllcall(IDirect3DSurface8.release, uint, pDest)
		dllcall(IDirect3DSurface8.release, uint, pSource)
		g_oni_ignorecopy := False		
		return			
	}
	return dllcall(IDirect3DTexture8.UnLockRect, uint, p1, uint, p2)
}

OniLoadReplacement(index, pOriginal)
{
	;logerr("Found " g_TextSwap8.dumps[index].replacement)
	if (tex := d3D8LoadManagedTexture(g_.pDevice8, g_TextSwap8.dumps[index].replacement))
	{
		if (old := g_TextSwap8.Replacements.value(replace))
			printl("Releasing IDirect3DTexture8 " dllcall(IDirect3DTexture8.release, uint, old))
		g_TextSwap8.Replacements._add(pOriginal, tex)
		
		
		if (no_alpha := g_oni_alphatexts.Value(pOriginal))
		{
			dllcall(IDirect3DTexture8.GetLevelDesc, uint, tex, uint, 0, uint, D3DSURFACE_DESC[])
			logerr("format " d3D8GetPixelFormat(D3DSURFACE_DESC.format))
			r := dllcall(IDirect3DDevice8.CreateTexture, uint, g_.pDevice8, uint, D3DSURFACE_DESC.width, uint, D3DSURFACE_DESC.Height, uint, 1
	                                                   , uint, 0, uint, d3D8SetPixelFormat("X8RGB"), uint, 1, "uint*", pTexture)
			if pTexture 
			{
				dllcall(IDirect3DTexture8.GetSurfaceLevel, uint, pTexture, uint, 0, "uint*", pDest)
				dllcall(IDirect3DTexture8.GetSurfaceLevel, uint, tex, uint, 0, "uint*", pSource)
				
				g_oni_ignorecopy := True
				logerr("copy" dllcall("peixoto.dll\d3D8LoadSurfaceFromSurface", uint, pDest, uint, pSource))
				dllcall(IDirect3DSurface8.release, uint, pDest)
				dllcall(IDirect3DSurface8.release, uint, pSource)
				g_oni_ignorecopy := False		
				
				if (old := g_TextSwap8.Replacements.value(no_alpha))
					printl("Releasing IDirect3DTexture8 " dllcall(IDirect3DTexture8.release, uint, old))
				g_TextSwap8.Replacements._add(no_alpha, pTexture)		
			}
		}		
	}
}

AltSetTexture(p1, p2, p3)
{
	/*
	TEXTSWAP8_DATA.searching := False
	if (p3 = TEXTSWAP8_DATA.Currentexture8)
	{
		g_TextSwap8.passes += 1
		g_TextSwap8.states.insert([])
		for k, v in [7, 23, "x", 52, 53, 54, 55, 56, 57, 58, 59, "x", 15, 24, 25, 27]
		{
			if (v = "x")
			{
				g_TextSwap8.states[g_TextSwap8.passes].insert("-")
				continue
			}
			dllcall(IDirect3DDevice8.GetRenderState, uint, p1, uint, v, "uint*", state)
			g_TextSwap8.states[g_TextSwap8.passes].insert(state & 0xFF)
		}
	}	
	*/
	;dllcall(IDirect3DDevice8.SetTextureStageState, uint, p1, uint, 0, uint, 16, uint, 1)
	;dllcall(IDirect3DDevice8.SetTextureStageState, uint, p1, uint, 0, uint, 17, uint, 1)
	;dllcall(IDirect3DDevice8.SetTextureStageState, uint, p1, uint, 0, uint, 18, uint, 0)
	if ( (tex := g_oni_alphatexts.value(p3)) and !numget(0x7ae0bc+0, "uint"))
	{
		dllcall(IDirect3DDevice8.GetRenderState, uint, p1, uint, 25, "uint*", test)
		dllcall(IDirect3DDevice8.GetRenderState, uint, p1, uint, 23, "uint*", zfunc)		
		if (test=7) or (zfunc=8) 
		{
			dllcall(IDirect3DTexture8.Release, uint, tex)
			g_oni_alphatexts.discard(p3)
			return dllcall(IDirect3DDevice8.SetTexture, uint, p1, uint, p2, uint, p3)
		}
		dllcall(IDirect3DDevice8.GetRenderState, uint, p1, uint, 27, "uint*", state)
		state ?: p3 := tex
	}
	return dllcall(IDirect3DDevice8.SetTexture, uint, p1, uint, p2, uint, p3)
}