;REMOTE SCRIPT START
HDHOOKS_DATA.BltSurface  := RegisterCallback("AltIDirectDrawSurface4_blt", "F")
logerr(IDirectDrawSurface4.UnHook("bltfast"))
logerr(IDirectDraw.UnHook("SetDisplayMode"))

if (g_.cfg.target_name != "wmain.exe") 
{
	logerr(IDirectDrawSurface4.Hook("GetSurfaceDesc"))
	logerr(IDirectDraw.Hook("Release"))
	logerr(IDirectDrawSurface4.UnHook("Flip"))
	logerr(IDirectDrawSurface4.Hook("Flip", "IDirectDrawSurface4_Flip"))
	global g_racerlock          := HDHOOKS_DATA.LockSurface
	global g_racerunlock        := HDHOOKS_DATA.UnLockSurface
	HDHOOKS_DATA.LockSurface    :=  RegisterCallback("Zlock", "F")
	HDHOOKS_DATA.UnLockSurface  :=	RegisterCallback("ZUnlock", "F")	
	logerr(IDirectInputDeviceW.Unhook("GetDeviceState")) 
	logerr(IDirectInputDeviceW.hook("GetDeviceState", "AltGetDeviceState", ,1))
}

IDirectDrawSurface4_GetSurfaceDesc(p1, p2)
{
	if (r := dllcall(IDirectDrawSurface4.GetSurfaceDesc, uint, p1, uint, p2))
		return r
	if (GetSurfaceCaps4(p1) & DDSCAPS_3DDEVICE)
	{
		if ! dllcall(IDirectDrawSurface4.GetSurfaceDesc, uint, g_.proxies.dev.surface4, uint, g_.DisplayDesc2[])
		{
			g_.DDSDesc2[] := p2
			(g_.cfg.32bit) ? SetPixelFormat(g_.DDSDesc2)
			if (g_.cfg.HD) 
			{
				g_.DDSDesc2.dwWidth  := g_.DisplayDesc2.dwWidth
				g_.DDSDesc2.dwHeight := g_.DisplayDesc2.dwHeight
				g_.DDSDesc2.lPitch   := g_.DisplayDesc2.lPitch
			}
		}
	}
	return r
}

IDirectDraw_Release(p1)
{
	if ((r := return dllcall(DirectDraw.Release, uint, p1)) = 1)
	{
		dllcall(IDirectDraw.release, uint, g_.pIDirectDraw) 
		g_.pIDirectDraw:=""
		return r
	}	
}

Alt_CreateSurface(pIDirectDraw4, pSurfaceDesc, ppSurface, pIUnknown)
{
	g_.DDSDesc2[] := pSurfaceDesc, caps := g_.DDSDesc2.ddsCaps.dwCaps
	
	g_.DDSDesc2.ddsCaps.dwCaps &= ~ DDSCAPS_SYSTEMMEMORY
	(caps & DDSCAPS_PRIMARYSURFACE) ? g_.DDSDesc2.ddsCaps.dwCaps := DDSCAPS_PRIMARYSURFACE 
							
	r := IDirectDraw4_CreateSurface(pIDirectDraw4, pSurfaceDesc, ppSurface, pIUnknown)	
	if (caps & DDSCAPS_ZBUFFER) 
	{
		(g_.proxies.zbuff) ? dllcall(IDirectDrawSurface4.release, uint, g_.proxies.zbuff)
		g_.proxies.zbuff := ""
		dllcall("ShowCursor", uint, 0)
		g_.DDSDesc2.dwWidth  := 640
		g_.DDSDesc2.dwHeight := 480
		g_.DDSDesc2.ddpfPixelFormat.dwRGBBitCount := 16
		g_.DDSDesc2.ddpfPixelFormat.dwGBitMask := 0xffff
		z := dllcall(IDirectDraw4.CreateSurface, uint, pIDirectDraw4, uint, pSurfaceDesc
	                                           , "uint*", zbuff, uint, pIUnknown, uint)
		g_.proxies.zbuff := zbuff			
	}
	return r
}

Zlock(p1, p2, p3, p4, p5)
{
	if (GetSurfaceCaps4(p1) & DDSCAPS_ZBUFFER) 
	{	
		blt := dllcall(IDirectDrawSurface4.blt, uint, g_.proxies.zbuff, uint, 0, uint, p1, uint, _RECT[]
									          , uint, DDBLT_WAIT, uint, g_HD.DDBLTFX[], uint)
		p1 := g_.proxies.zbuff 
	}
	r := dllcall(g_racerlock, uint, p1, uint, p2, uint, p3, uint, p4, uint, p5, uint)
	return r
}

ZUnLock(p1, p2)
{
	if (GetSurfaceCaps4(p1) & DDSCAPS_ZBUFFER) 
	{
		DDBLTFX.dwFillDepth  := 0xffffff
		r   := dllcall(IDirectDrawSurface4.UnLock, uint, g_.proxies.zbuff, uint, p2)
		blt := dllcall(IDirectDrawSurface4.blt, uint, p1, uint, _rect[], uint, 0, uint, 0
											  , uint, DDBLT_DEPTHFILL, uint, DDBLTFX[], uint)
		return r											  
	}
	return dllcall(g_racerunlock, uint, p1, uint, p2)
}

AltIDirectDrawSurface4_blt(p1, p2, p3, p4, p5, p6)
{
	if (GetSurfaceCaps4(p1) & DDSCAPS_ZBUFFER) 
	{
		g_.zbuff        := p1
		if (g_HD.rect[] := p2)
		{
			g_HD.rect.top    *= g_.resolution_correction 
			g_HD.rect.bottom *= g_.resolution_correction 
			g_HD.rect.left   *= g_.resolution_correction 
			g_HD.rect.left   += g_.viewport_correction
			g_HD.rect.right  *= g_.resolution_correction 
			g_HD.rect.right  += g_.viewport_correction	
		}				
	}	
	return dllcall(IDirectdrawSurface4.blt, uint, p1, uint, p2, uint, p3, uint, p4
										  , uint, p5, uint, p6, uint) 
}

AltIDirectDrawSurface4_flip(p1, p2, p3)
{	
	DDBLTFX.dwFillDepth  := 0x0
	blt := dllcall(IDirectDrawSurface4.blt, uint, g_.zbuff, uint, 0, uint, 0, uint, 0
										  , uint, DDBLT_DEPTHFILL, uint, DDBLTFX[], uint)
		
	return IDirectDrawSurface4_flip(p1, p2, p3)		
}

AltIDirect3DViewPort3_Clear2(p1, p2, p3, p4, p5, p6, p7)
{
	return IDirect3DViewPort3_Clear2(p1, p2, p3, 1, p5, p6, p7)
	return IDirect3DViewPort3_Clear2(p1, p2, p3, 1, 0, p6, p7)
}

AltGetDeviceState(p1, p2, p3)
{
	r := dllcall(g_dinputemu.p[A_eventinfo], uint, p1, uint, p2, uint, p3)

	
	if ( (p2 = 80) )
	{		
		if XinputGetState(1)	
			return r
		
		callback := "xinputcallback"
		DIJOYSTATEEX[] := p3
		loop, 32
			DIJOYSTATEEX.rgbButtons[A_index] := 0
		
		DIJOYSTATEEX.lX := 32767,	DIJOYSTATEEX.lY := 32767, DIJOYSTATEEX.lZ := 32767	
		DIJOYSTATEEX.lRX := 32767,	DIJOYSTATEEX.lRY := 32767, DIJOYSTATEEX.lRZ := 32767	
		
		if g_dinputemu.deadzone 
		{	
			if XINPUT_GAMEPAD.sThumbLX > g_dinputemu.deadzone 
				DIJOYSTATEEX.lX := XINPUT_GAMEPAD.sThumbLX * 0xffff/32768
			else if XINPUT_GAMEPAD.sThumbLX < g_dinputemu.deadzone_minus 
				DIJOYSTATEEX.lX := XINPUT_GAMEPAD.sThumbLX * 0xffff/32768
			
			if XINPUT_GAMEPAD.sThumbLY > g_dinputemu.deadzone
				DIJOYSTATEEX.LY := -XINPUT_GAMEPAD.sThumbLY * 0xffff/32768
			else if XINPUT_GAMEPAD.sThumbLY < g_dinputemu.deadzone_minus 
				DIJOYSTATEEX.LY := -XINPUT_GAMEPAD.sThumbLY * 0xffff/32768
			
			if XINPUT_GAMEPAD.sThumbRX > g_dinputemu.deadzone 
				DIJOYSTATEEX.lRX := XINPUT_GAMEPAD.sThumbRX * 0xffff/32768
			else if XINPUT_GAMEPAD.sThumbRX < g_dinputemu.deadzone_minus 
				DIJOYSTATEEX.lRX := XINPUT_GAMEPAD.sThumbRX * 0xffff/32768
			
			if XINPUT_GAMEPAD.sThumbRY > g_dinputemu.deadzone
				DIJOYSTATEEX.lRY := -XINPUT_GAMEPAD.sThumbRY * 0xffff/32768
			else if XINPUT_GAMEPAD.sThumbRY < g_dinputemu.deadzone_minus 
				DIJOYSTATEEX.lRY := -XINPUT_GAMEPAD.sThumbRY * 0xffff/32768
		}
				
		XINPUT_GAMEPAD_DPAD_RIGHT ? DIJOYSTATEEX.lX := 0xffff : XINPUT_GAMEPAD_DPAD_LEFT ? DIJOYSTATEEX.lX := -0xffff
		XINPUT_GAMEPAD_DPAD_DOWN ? DIJOYSTATEEX.lY := 0xffff : XINPUT_GAMEPAD_DPAD_UP ? DIJOYSTATEEX.lY := -0xffff
						
		for k, v in g_dinputemu.controls
		{
			if (k < 11)
			{
				val = % XINPUT_GAMEPAD_%v%	
				valprev = % XINPUT_GAMEPAD_%v%_PREV
			}				
			else 
			{
				val := XINPUT_GAMEPAD[v]
				valprev	:= XINPUT_GAMEPAD[v "_prev"]
			}	

			z := g_dinputemu.xinput[v] 						
			if z is number 	
				 val ? DIJOYSTATEEX.rgbButtons[g_dinputemu.xinput[v]] := 128 		
			else val ? valprev ?: isfunc(callback) ? %callback%(z) 			
		}					
	}	
	return r
}