;REMOTE SCRIPT START

isobject(IDirectSoundBuffer) ? logerr(IDirectSoundBuffer.PatchVtable("Play"))
g_.cfg.frameTime += 0.
global GetVersion, GetVersionEX
logerr("GetVersion Hook   : " InstallHook("GetVersion", GetVersion, "Kernel32.dll", "GetVersion") " <- 0 means no error")
logerr("GetVersionExA Hook   : " InstallHook("GetVersionExA", GetVersionEX, "Kernel32.dll", "GetVersionExA") " <- 0 means no error")

GetVersion()
{
	;ver := dllcall(GetVersion, uint)
	;logerr("ver" ver)
	return 3283484676
}

GetVersionExA(p1)
{
	;r := dllcall(GetVersionEX, uint, p1)
	OSVERSIONINFO := struct("DWORD OSVersionInfoSize;  DWORD MajorVersion;  DWORD MinorVersion;  DWORD BuildNumber; DWORD PlatformId;  TCHAR szCSDVersion[128];")
	OSVERSIONINFO[] := p1
	OSVERSIONINFO.OSVersionInfoSize := 148
	OSVERSIONINFO.MajorVersion:=  4
	OSVERSIONINFO.MinorVersion:=  0
	OSVERSIONINFO.BuildNumber:=  950
	OSVERSIONINFO.PlatformId:=  1
	for k, v in OSVERSIONINFO
		logerr(k " " v)
	return 1
}

if g_.cfg.create_links
{
	links := []
	loop, 8
		links.insert("savedat" A_index ".dat")
	CreateLinksCollection(links, "ResidentEvil")
}	

AltIDirect3DDevice_EndScene(p1)
{
	critical
	static freq, lastflip = 0 
		
	freq ?:	DllCall("QueryPerformanceFrequency", "Int64*", freq)			
	DllCall("QueryPerformanceCounter", "Int64*", timenow)
	
	while not  (timenow - lastflip)/freq*1000 >= g_.cfg.frameTime
		DllCall("QueryPerformanceCounter", "Int64*", timenow)
	lastflip := timenow
	
	r := IDirect3DDevice_EndScene(p1)
	return r
}

IDirectSoundBuffer_Play(p1, p2, p3, p4)
{
	if (p4 & DSBPLAY_LOOPING)
	{
		DSBCAPS.dwSize := DSBCAPS.size()
		dllcall(IDirectSoundBuffer.GetCaps, uint, p1, uint, DSBCAPS[])
		printl("sndbuffersize" DSBCAPS.dwBufferBytes)
		if (DSBCAPS.dwBufferBytes > 60000)
			return 0
	}
	r := dllcall(IDirectSoundBuffer.Play, uint, p1, uint, p2, uint, p3, uint, p4)
	return r
}

Alt_CreateSurface(pIDirectDraw, pSurfaceDesc, ppSurface, pIUnknown)
{
	static SurfaceDesc 
	SurfaceDesc ?: SurfaceDesc := ddSurfaceDesc.clone()		
	SurfaceDesc[] := pSurfaceDesc
	
	if (SurfaceDesc.ddsCaps.dwCaps & DDSCAPS_ZBUFFER)
		logerr("Zbuffer depth " SurfaceDesc.dwZBufferBitDepth)
	
	flags := SurfaceDesc.dwFlags
	caps := SurfaceDesc.ddsCaps.dwCaps
	r := __IDirectDraw_CreateSurface(pIDirectDraw, pSurfaceDesc, ppSurface, pIUnknown, A_eventinfo)
	;setformat, integer, hex	
	r ? logerr("Failed to create surface " r ": " ddraw.err[r . ""] " " flags " " caps " " g_.res.w " " g_.res.h)
	if r and (SurfaceDesc.ddsCaps.dwCaps & DDSCAPS_ZBUFFER) or flags & 
	{
		if (SurfaceDesc.dwZBufferBitDepth = 32)
			SurfaceDesc.dwZBufferBitDepth := 24   
		else SurfaceDesc.dwZBufferBitDepth := 32
		r := __IDirectDraw_CreateSurface(pIDirectDraw, pSurfaceDesc, ppSurface, pIUnknown, A_eventinfo) 
		if r 
		{
			logerr("Failed to create a " SurfaceDesc.dwZBufferBitDepth " bit Zbuffer " r ": " ddraw.err[r . ""])
			SurfaceDesc.dwZBufferBitDepth := 16
			r := __IDirectDraw_CreateSurface(pIDirectDraw, pSurfaceDesc, ppSurface, pIUnknown, A_eventinfo) 
			if r 
				logerr("Failed to create a 16 bit Zbuffer " r ": " ddraw.err[r . ""])
		}
	}		
	return r 
}