;REMOTE SCRIPT START
(g_.cfg.mods) ?:	InitFileHooks((g_.cfg.mods := "?"))
logerr("CloseHandle Hook  : " InstallHook("CloseHandle", pCloseHandle, "Kernel32.dll", "CloseHandle") " <- 0 means no error")	
g_.pCloseHandle := pCloseHandle
g_.POP_FMVHwnd := -1

g_ShaderOverride9.override_code := 
(
"
sampler s0 : register(s0);
float4 main(float2 tex : TEXCOORD0, float4 diff : COLOR0) : COLOR0
{
	return tex2D(s0, tex) * diff;
}
"
)
/* The launcher will edit this everytime the game starts,
 * so we either edit again or set it to read only
 */
if fileexist("Hardware.ini")
{
	f=Hardware.ini
	IniWrite, 1, %f%, CAPS, ForceVSFog
	IniWrite, 0, %f%, CAPS, InvertFogRange
	IniWrite, 0, %f%, CAPS, ZEnableFix
}
res := GetDeskTopResolution()
w := res.w, h := res.h
if fileexist("POP.ini")
{
	f=POP.ini
	IniWrite, %w%, %f%, MAIN, Width 
	IniWrite, %h%, %f%, MAIN, Height 
}
;g_.cfg.FMV_scale := 2.13
fmv_w := 640*g_.cfg.FMV_scale 
fmv_h := 346*g_.cfg.FMV_scale 
while (fmv_w > w) or (fmv_h > h)
{
	g_.cfg.FMV_scale  -= 0.01
	fmv_w := 640*g_.cfg.FMV_scale 
	fmv_h := 346*g_.cfg.FMV_scale 
}

fmv_x := ((w-fmv_w)/2)-0.5
fmv_y := ((h-fmv_h)/2)-0.5
fmv_w += fmv_x-0.5
fmv_h += fmv_y-0.5

global FMV_rect := dllcall("VirtualAlloc", ptr, 0, ptr, 96, uint, 0x00001000 | 0x00002000
								         , uint, (PAGE_READWRITE := 0x04), ptr )
for k, v in [fmv_x, fmv_y, 1., 1., 0.   , 0.
			,fmv_w, fmv_y, 1., 1., 0.625, 0.
			,fmv_w, fmv_h, 1., 1., 0.625, 0.67578125
			,fmv_x, fmv_h, 1., 1., 0.   , 0.67578125]
		numput(v, FMV_rect+(k-1)*4, "float")											 

AltIDirect3DDevice9_EndScene(p1)
{
	if (g_.POP_FMVHwnd > 0)
	{
		dllcall(IDirect3DDevice9.Clear, uint, g_.pDevice9, uint, 0, uint, 0
									  , uint, 0x00000001, uint, 0 ,uint, 0, uint, 0)
		
		dllcall(IDirect3DDevice9.GetPixelShader, uint, g_.pDevice9, "uint*", pCurrentShader)
		dllcall(IDirect3DDevice9.GetVertexShader, uint, g_.pDevice9, "uint*", pCurrentVShader)
		dllcall(IDirect3DDevice9.GetFVF, uint, g_.pDevice9, "uint*", current_FVF, uint) 	
		
		dllcall(IDirect3DDevice9.SetPixelShader, uint, g_.pDevice9, uint, SHADEROVERRIDE9_DATA.override)	
		dllcall(IDirect3DDevice9.SetVertexShader, uint, g_.pDevice9, uint, 0)
		dllcall(IDirect3DDevice9.SetFVF, uint, g_.pDevice9, uint, D3DFVF_XYZRHW | D3DFVF_TEX1, uint) 		
		
		dllcall(IDirect3DDevice9.DrawPrimitiveUP, uint, g_.pDevice9, uint, (D3DPT_TRIANGLEFAN := 6), uint, 2, uint, FMV_rect, uint, 24)	
		
		dllcall(IDirect3DDevice9.SetPixelShader, uint, g_.pDevice9, uint, pCurrentShader)
		dllcall(IDirect3DDevice9.SetVertexShader, uint, g_.pDevice9, uint, pCurrentVShader)
		dllcall(IDirect3DDevice9.SetFVF, uint, g_.pDevice9, uint, current_FVF, uint) 
		
		pCurrentShader ? dllcall(IDirect3DPixelShader9.release, uint, pCurrentShader)
		pCurrentVShader ? dllcall(IDirect3DVertexShader9.release, uint, pCurrentShader)	
	}		
	
	return IDirect3DDevice9_EndScene(p1)
}

AltCreateFileA(p1, p2, p3, p4, p5, p6, p7)
{
	file := strget(p1, "CP0")
	;printl("file " file)	
	if instr(file, ".int")
	{
		if ( instr(file, "VIS") or instr(file, "Cine") )
		{
			return (g_.POP_FMVHwnd := CreateFileA(p1, p2, p3, p4, p5, p6, p7))			
		}			
		return -1
	}		
	return CreateFileA(p1, p2, p3, p4, p5, p6, p7)	
}

CloseHandle(hwnd)
{
	if (hwnd = g_.POP_FMVHwnd) 
		g_.POP_FMVHwnd := -1
	return dllcall(g_.pCloseHandle, uint, hwnd)
}