﻿printl("Ok")
GetDirect3D7()
global target := A_scriptOptions
if not target
{
	msgbox, 16, ,Drag and drop the dds file you want to split over the program
	exitapp
}	
global source_surf7 := SpliterLoadSurface7(IDirectDraw7.p, target)
global refsize := {"w" : 320, "h" : 240}
global source_size := {"w" : DDS_HEADER.dwWidth , "h" :  DDS_HEADER.dwHeight}

gui, add, Text, ,Choose a layout
gui, add, radio, vRE checked1,Resident Evil Background 
gui, add, radio, vRE2 ,Resident Evil 2 Background 
gui, add, radio, vTR2 ,Tomb Raider II title screen
gui, add, button, x+25 y+10 w80 h30, Split
gui, show
return

buttonsplit:
	gui, submit, nohide
	if RE 
		RE()
	else if RE2
		RE2()
	else if TR2
		TR2()
msgbox, 64, , Done!	
exitapp
return

guiclose:
exitapp

RE()
{
	f := GetFiles(2)
	split(f[1], "256,256", ["0,0,0,0,256,240"])
	split(f[2], "256,256", ["256,0,0,0,64,240"])
}

RE2()
{
	f := GetFiles(2)
	split(f[1], "256,256",  ["0,0,0,0,256,240"])
	split(f[2], "128,128",  ["256,0,0,0,64,128", "256,128,64,0,64,112"])
}

TR2()
{
	refsize := {"w" : 640, "h" : 480}
	f := GetFiles(5)
	split(f[1], "256,256",  ["0,0,0,0,256,256"])
	split(f[2], "256,256",  ["0,256,0,0,256,224"])
	split(f[3], "256,256",  ["256,0,0,0,256,256"])
	split(f[4], "256,256",  ["256,256,0,0,256,224"])
	split(f[5], "256,256",  ["512,0,0,0,128,256", "510,256,128,0,128,224"])
}

GetFiles(n)
{
	sufixes := strsplit("ABCDEFGH")
	splitpath, target, ,dir ,target_ext, target_name
	overrides := ""
	files := []
	loop, % n	
	{
		file := dir "\" target_name sufixes[A_index] "." target_ext
		if fileexist(file) 
			overrides .= file "`n"	
		files.insert(file)
	}
	
	if overrides
	{
		msgbox, 49 , , Files`n%overrides%already exist, Overwrite?
		ifmsgbox, cancel
			ExitApp
	}
	return files	
}	

dumpSurface7(pSurface,  file)
{
	GUID_FromString(idd_surface, ddraw.IID_IDirectDrawSurface)
	dllcall(IDirectDrawSurface7.QueryInterface, uint, pSurface, uint, &idd_surface, "uint*", pSurface1, uint)	
	dumpSurface(pSurface1, file)	
	pSurface ? dllcall(IDirectDrawSurface.release, uint, pSurface1)	
}

split(file, size, rects)
{
	static pLoadData2Surface, desc, src_rect, dst_rect
	if not pLoadData2Surface
	{
		pLoadData2Surface := dllcall("GetProcAddress", uint, dllcall("GetModuleHandle", str, "peixoto.dll", uint)
													 , astr, "LoadData2Surface", uint)	
		(desc := struct(ddSurfaceDesc2)).dwSize := desc.size()
		src_rect := struct(rect), dst_rect := struct(rect)	
	}
	
	size := strsplit(size, ",")
		
	desc.dwSize := DDSURFACEDESC2.size()
	desc.dwFlags := DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT 
	desc.dwWidth := size[1]/refsize.w * source_size.w
	desc.dwHeight := size[2]/refsize.h * source_size.h
	desc.ddsCaps.dwCaps  :=  DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY	
	setPixelFormat(desc, getFilePixelFormat(DDS_HEADER))
	r := dllcall(IDirectDraw7.CreateSurface, uint, IDirectDraw7.p, uint, desc[]
										   , "ptr*", pSurface, uint, 0, uint)										   
										   
	for k, v in rects
	{
		scalex := refsize.w / source_size.w 
		scaley := refsize.h / source_size.h 
		printl(scalex " " scaley)
		lrect := strsplit(v, ",")
		
		src_rect.left := lrect[1]/scalex
		src_rect.top  := lrect[2]/scaley		
		src_rect.right    := (lrect[1]+lrect[5])/scalex
		src_rect.bottom   := (lrect[2]+lrect[6])/scaley
		
		dst_rect.left := lrect[3]/scalex 
		dst_rect.top  := lrect[4]/scaley
		dst_rect.right    := (lrect[3]+lrect[5])/scalex
		dst_rect.bottom   := (lrect[4]+lrect[6])/scaley
		
		for k, v in src_rect
			printl(k " " v)
		
		blt := dllcall(IDirectDrawSurface7.blt, uint, pSurface, uint, dst_rect[], uint, source_surf7, uint, src_rect[]
									          , uint, 0, uint, 0, uint)
		printl("blt " blt ddraw.err[blt . ""])									  
	}
	dumpSurface7(pSurface,  file)
}

SpliterLoadSurface7(pInterface, file_)
{
	colorkey ?: colorkey := {"RG6B" : 0x07e0, "X1RGB" : 0}
	static pLoadData2Surface, desc 
	if not pLoadData2Surface
	{
		pLoadData2Surface := dllcall("GetProcAddress", uint, dllcall("GetModuleHandle", str, "peixoto.dll", uint)
													 , astr, "LoadData2Surface", uint)	
		(desc := struct(ddSurfaceDesc2)).dwSize := desc.size()	
	}
		
	pixelformat := OpenDDS(file_, hFile)						
	desc.dwSize := DDSURFACEDESC2.size()
	desc.dwFlags := DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT 
	desc.dwWidth := DDS_HEADER.dwWidth 
	desc.dwHeight := DDS_HEADER.dwHeight		
	desc.ddsCaps.dwCaps  :=  DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY		
	if ! instr(pixelformat, "A")	{
		desc.dwFlags |= DDSD_CKSRCBLT 
		desc.ddckCKSrcBlt.dwColorSpaceLowValue := colorkey[pixelformat]
		desc.ddckCKSrcBlt.dwColorSpaceHighValue := colorkey[pixelformat]
	}
	setPixelFormat(desc, pixelformat)		
	
	r := dllcall(IDirectDraw7.CreateSurface, uint, pInterface, uint, desc[]
										   , "ptr*", pSurface, uint, 0, uint)
	printl("Texture Load Surface: "	r " " ddraw.err[r . ""])
    printl("vtable " numget(pSurface+0, "ptr"))	
	r := dllcall(IDirectDrawSurface7.Lock, uint, pSurface, uint, 0, uint, desc[], uint, DDLOCK_WRITEONLY, uint, 0, uint)
	printl("Texture Load Lock: " r " " ddraw.err[r . ""])		
		
	pitch := desc.lpitch
	pSurfdata := desc.lpSurface
	hLines := DDS_HEADER.dwHeight								 
	
	if (r := dllcall(pLoadData2Surface, uint, pSurfdata, uint, hFile, uint, pitch, uint, desc.dwWidth
	                                  , uint, hLines, uint, DDS_HEADER.ddspf.dwRGBBitCount/8))
	{
		printl("Texture Load - Copy " r)
		size := desc.dwWidth*DDS_HEADER.ddspf.dwRGBBitCount/8
		loop, % hLines
			dllcall("ReadFile", uint, hFile, uint, pSurfdata + pitch * (A_index-1), uint, size, uint, 0, uint, 0)	
	}							
	dllcall("CloseHandle", uint, hFile)								 
	
	r := dllcall(IDirectDrawSurface7.UnLock, uint, pSurface, uint, ddSurfaceDesc.lpSurface)
	printl("Texture Load UnLock: " r " " ddraw.err[r . ""])	
	return pSurface
}