;REMOTE SCRIPT START
logErr(IDirectDraw2.hook("SetDisplayMode"))
logErr(IDirectDrawSurface4.Unhook("QueryInterface"))
logErr(IDirectDrawSurface.hook("QueryInterface"))
 
AltIDirectDraw2_SetDisplayMode(p1, p2, p3, p4, p5, p6)
{
	g_.proxies := {}
	ComputeResolutionCorrections(p2, p3)
	dllcall(IDirectDraw2.GetDisplayMode, uint, p1, uint, g_.DisplayDesc[])
	if (g_.desktop.w!=g_.DisplayDesc.dwWidth) or (g_.desktop.h!=g_.DisplayDesc.dwHeight) or (32!=g_.DisplayDesc.ddpfPixelFormat.dwRGBBitCount)
	r := dllcall(IDirectDraw2.SetDisplayMode, uint, p1, int, g_.desktop.w, int, g_.desktop.h, int, p4, int, p5, int, p6, uint)
    printl("IDirectDraw2_SetDisplayMode " r draw.result[r . ""])				
	return r
}

AltIDirectDrawSurface_QueryInterface(p1, p2, p3)
{
	r := IDirectDrawSurface4_QueryInterface(p1, p2, p3)		
	if (GetSurfaceCaps(p1) & DDSCAPS_PRIMARYSURFACE)
	{
		if not g_.proxies.D3D 
		{ 
			g_.proxies.D3D        := new D3D3Device((640<<16)|480)
			g_.proxies.prim       := new SurrogateSurface4("RG6B", (1025<<16)|765, True)
			g_.proxies.dev        := new SurrogateSurface4("RG6B", (640<<16)|480, True)
		}
		g_.proxies_shader := d3D9_DDI_CreatePixelShader(g_d3D9_DDI.shader_code, "LineDoubling")
		g_.rect := struct(rect), g_.rect.top := 0, g_.rect.left := 0, g_.rect.right := 640, g_.Rect.bottom := 480
		dllcall(IDirectDrawSurface.blt, uint, p1, uint, 0, uint, 0, uint, 0, uint
										    , DDBLT_COLORFILL, uint, DDBLTFX[], uint) 	
		if not (GetSurfaceCaps(p1) & DDSCAPS_3DDDEVICE) {
		IDirectDrawSurface2.PatchVtable("lock")
		IDirectDrawSurface2.PatchVtable("Unlock")
		}		
	} return r
}


Alt_lock(p1, p2, p3, p4, p5)
{
	if (GetSurfaceCaps(p1) & DDSCAPS_PRIMARYSURFACE)
		p1 := g_.proxies.prim.Surface
	r := dllcall(IDirectDrawSurface2.lock, uint, p1, uint, p2, uint, p3, uint, p4, uint, p5, uint)
	return r
}	

Alt_Unlock(p1, p2)
{
	(GetSurfaceCaps(p1) & DDSCAPS_PRIMARYSURFACE) ? (prim := p1, p1 := g_.proxies.prim.Surface)
	r := dllcall(IDirectDrawSurface2.Unlock, uint, p1, uint, p2)
	if (p1 = g_.proxies.prim.surface)
	{
		dllcall(IDirectDrawSurface.blt, uint, g_.proxies.dev.Surface, uint,  g_.rect[]
		                              , uint, g_.proxies.prim.surface, uint, g_.rect[]
									  , uint, DDBLTFAST_NOCOLORKEY | DDBLT_WAIT, uint, 0, uint)	
									  
		DEVICE3_RECT.Texture := g_.proxies.dev.Texture2
		DEVICE3_RECT.Device3 := g_.proxies.D3D.Device3
		d3D9_DDI_SetShaderOverride(g_.proxies_shader)
		dllcall(g_.Dev3_DrawRect, uint, DEVICE3_RECT[], uint, g_.rect[], float, 0, uint)
		d3D9_DDI_RestoreShader()
		
		_rect_setscale(g_.cfg.FMVScale)							 
		dllcall(IDirectDrawSurface.blt, uint, prim, uint,  _rect[]
		                             , uint, g_.proxies.D3D.surface, uint, g_.rect[]
									 , uint, DDBLTFAST_NOCOLORKEY | DDBLT_WAIT, uint, 0, uint)	
		_rect_setscale(0)								 
	}
	return r
}

/*
AltDDrawCreate(p1, p2, p3)
{
	(g_.pIDirectDraw) ? g_.pIDirectDraw := dllcall(IDirectDraw.Release, uint, g_.pIDirectDraw) * 0
	if (r := dllcall(g_.pDirectDrawCreate, uint, p1, uint, p2, uint, p3))
		return r
	g_.pIDirectDraw := numget(p2+0, "ptr")
	dllcall(IDirectDraw.addref, uint, g_.pIDirectDraw)	
	return r
}
*/
